# Source Generated with Decompyle++
# File: in.pyo (Python 2.5)

import re
import dns.exception as dns
RESERVED0 = 0
IN = 1
CH = 3
HS = 4
NONE = 254
ANY = 255
_by_text = {
    'RESERVED0': RESERVED0,
    'IN': IN,
    'CH': CH,
    'HS': HS,
    'NONE': NONE,
    'ANY': ANY }
_by_value = []([ (y, x) for x, y in _by_text.iteritems() ])
_by_text.update({
    'INTERNET': IN,
    'CHAOS': CH,
    'HESIOD': HS })
_metaclasses = {
    NONE: True,
    ANY: True }
_unknown_class_pattern = re.compile('CLASS([0-9]+)$', re.I)

class UnknownRdataclass(dns.exception.DNSException):
    pass


def from_text(text):
    value = _by_text.get(text.upper())
    if value is None:
        match = _unknown_class_pattern.match(text)
        if match == None:
            raise UnknownRdataclass
        
        value = int(match.group(1))
        if value < 0 or value > 65535:
            raise ValueError, 'class must be between >= 0 and <= 65535'
        
    
    return value


def to_text(value):
    if value < 0 or value > 65535:
        raise ValueError, 'class must be between >= 0 and <= 65535'
    
    text = _by_value.get(value)
    if text is None:
        text = 'CLASS' + `value`
    
    return text


def is_metaclass(rdclass):
    if _metaclasses.has_key(rdclass):
        return True
    
    return False

